unit formCallcenter;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	ComCtrls, StdCtrls, ExtCtrls, Spin;

type
  TfrmCallcenter = class(TForm)
    Panel1: TPanel;
    Label2: TLabel;
    Label1: TLabel;
    ButtonMakeCall: TButton;
    ButtonHangUp: TButton;
    EditNr: TEdit;
    EditMSN: TEdit;
    EditDTMF: TEdit;
    ButtonSendDTMF: TButton;
    ButtonAcceptCall: TButton;
    s: TPageControl;
    CallState: TTabSheet;
    MemoCallstate: TMemo;
    TabSheet3: TTabSheet;
    MemoDTMF: TMemo;
    TabSheet1: TTabSheet;
    MemoInfo: TMemo;
    TabSheet2: TTabSheet;
    MemoError: TMemo;
    GroupBox4: TGroupBox;
    EditWavefilename: TEdit;
    BtnSendWave: TButton;
    BtnECT: TButton;
    EditECTDestination: TEdit;
    PageControl1: TPageControl;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TrackBarVolume: TTrackBar;
    RBHeadset: TRadioButton;
    RBHandset: TRadioButton;
    SESpkGain: TSpinEdit;
    SEMicGain: TSpinEdit;
    SEspSpk: TSpinEdit;
    SEspMic: TSpinEdit;
    SEHandsetMic: TSpinEdit;
    SEHandsetSpk: TSpinEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    TabSheet6: TTabSheet;
    RBDIVAHandset: TRadioButton;
    Label12: TLabel;
    RBDIVASpeakerphone: TRadioButton;
		procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonMakeCallClick(Sender: TObject);
    procedure ButtonHangUpClick(Sender: TObject);
    procedure ButtonAcceptCallClick(Sender: TObject);
    procedure ButtonSendDTMFClick(Sender: TObject);
    procedure VolumeChange(Sender: TObject);
		procedure BtnSendWaveClick(Sender: TObject);
    procedure BtnECTClick(Sender: TObject);
    procedure SEHandsetMicChange(Sender: TObject);
    procedure RBDIVAHandsetClick(Sender: TObject);
  private
		{ Private-Deklarationen }
	protected
		procedure LimitMemoSize;

  public
    { Public-Deklarationen }
    gLizenzName,
    gLizenzKey: String;

    ISDNDataHandle: Pointer;
    bISDNInit : Boolean;
  end;

var
  frmCallcenter: TfrmCallcenter;

implementation

uses DSPModuleIntf, DSPModuleDecl;

{$R *.DFM}

// Memos lschen, wenn zu vielen Daten enthalten sind
// die normalen TMemos knnen nur ca. 30kb Text verkraften 
procedure TfrmCallcenter.LimitMemoSize;
var x: integer;
const MAX_MEMO_LINES = 1000;
begin
	for x := 1 to ComponentCount do
		if Components[x-1] is TMemo then
			with Components[x-1] as TMemo do
				if Lines.Count > MAX_MEMO_LINES Then
					Lines.Clear;
end;

{**************************************************************************
* Function   :  TraceProc
* Description:  Ausgabe von Informationen ber das ISDN-Modul (OPTIONAL)
* Arguments  :
		TraceType = INFO oder ERROR,
		Text = Der Info- oder Error-Text
***************************************************************************}
procedure TraceProc ( TraceType: integer; Text: PChar ); stdcall;
begin
	frmCallcenter.LimitMemoSize;

	case TraceType of
	TRACETYPE_INFO :  frmCallcenter.MemoInfo.Lines.Add(  StrPas(Text) );
	TRACETYPE_ERROR:  frmCallcenter.MemoError.Lines.Add(  StrPas(Text) );
	end;
end;

{**************************************************************************
* Function   :  CallStateProc
* Description:  Informationen ber den Anruf-Status
* Arguments  :
		State = Der aktuelle Status
		lpCallData = Pointer auf zustzliche Daten, evtl. auch nil
***************************************************************************}
procedure CallStateProc (LineID: Byte; State: TCallState; lpCallData: Pointer); stdcall;
const
	arBoolean        : array[Boolean] of string = ('Nein', 'Ja');
	arAuflegerichtung : array[0..1] of string = ('Aktiv', 'Passiv');
	arLineID				 : array[1..3] of string = ('Telephony', 'CallWaiting', 'ECT-Destination');
begin
	frmCallcenter.LimitMemoSize;

	if (LineID=LINEID_TELEPHONY) then
	begin
		frmCallcenter.ButtonMakeCall.Enabled := State in [csBereit];
		frmCallcenter.ButtonHangUp.Enabled := State in [csAnruf, csVerbinde, csVerbunden];
		frmCallcenter.ButtonAcceptCall.Enabled := State in [csAnruf];
		frmCallcenter.ButtonSendDTMF.Enabled := State in [csVerbunden];
		frmCallcenter.BtnSendWave.Enabled := State in [csVerbunden];
		frmCallcenter.BtnECT.Enabled := State in [csVerbunden];
	end;

	 case State of
	 csAnruf:
		 with PAnrufInfo(lpCallData)^ do
			 frmCallcenter.MemoCallstate.Lines.Add(
				 arLineID[LineID]+' [csAnruf] Anruf von ' + AnruferNummer + ' an ' + MSN
			 );

		 csAufgelegt:
				 with PDisconnectInfo(lpCallData)^ do
						 frmCallcenter.MemoCallstate.Lines.Add(
								 Format('%s [csAufgelegt] Verbunden: %s, AuflegeRichtung: %s, Fehler: %s, FehlerCode: %.4x', [

										 arLineID[LineID],
										 arBoolean[Verbunden],
										 arAuflegerichtung[Auflegerichtung],
										 arBoolean[Fehler],
										 FehlerCode
									]));

		 csBereit:
						 frmCallcenter.MemoCallstate.Lines.Add(arLineID[LineID]+' [csBereit]');

		 csVerbinde:
						 frmCallcenter.MemoCallstate.Lines.Add(arLineID[LineID]+' [csVerbinde...]');

		 csVerbunden:
				 with PConnectInfo(lpCallData)^ do
						 frmCallcenter.MemoCallstate.Lines.Add(
								 Format('%s [csVerbunden] VerbindungsModus: %d, Fehler: %s', [
										 arLineID[LineID],
										 VerbindungsModus,
										 arBoolean[Fehler] ]));

		 csOnHold:
						 frmCallcenter.MemoCallstate.Lines.Add(arLineID[LineID]+' [csOnHold]');
	 end;
end;


{**************************************************************************
* Function   :  DTMFProc
* Description:  DTMF-Informationen
* Arguments  :
		DTMFType = dtmfSendResult, dtmfDetectInit, dtmfDetected
		lpDTMFData = Pointer auf zustzliche Daten
***************************************************************************}
procedure DTMFProc (DTMFType: TDTMFType; lpDTMFData: Pointer); stdcall;
begin
	frmCallcenter.LimitMemoSize;

	case DTMFType of
	dtmfSendResult: frmCallcenter.MemoDTMF.Lines.Add( 'DTMF SendResult: '+IntToStr(PLongInt(lpDTMFData)^) );
	dtmfDetectInit: frmCallcenter.MemoDTMF.Lines.Add( 'DTMF DetectInit: '+IntToStr(PLongInt(lpDTMFData)^) );
	dtmfDetected: frmCallcenter.MemoDTMF.Lines.Add( 'DTMF Detected: '+StrPas(PChar(lpDTMFData)) );
	end;
end;

{**************************************************************************
* Function   :  QueryTapeProc
* Description:  Anruf-Mitschnitt aktivieren?
* Arguments  :
		lpQueryTapeData = Einstellungen fr den Mitschnitt, u.a. Dateiname
  Hinweis: die Daten werden im Format PCM, 8000 hz, 16 bit, Mono aufgezeichnet
***************************************************************************}
procedure QueryTapeProc (lpQueryTapeData: Pointer ); stdcall;
begin
	frmCallcenter.LimitMemoSize;

	with PQueryTapeData(lpQueryTapeData)^ do
		begin
			Enable := true;
			MaxRecordTime := 0; // Kein Zeitlimit
			StrCopy( Filename, 'tape.wav');
		end;
end;

procedure TfrmCallcenter.FormCreate(Sender: TObject);
var InitParam: TInitParam;
	szBuffer : array[0..2000] of char;
	Error: LongInt;
	DTMFDurations: TDTMFDurations;
  LizenzDatei: TStringList;

const
	constAcceptThisMSN = '12345'; // nur MSN '12345' reagieren
  constAcceptAllMSN  = ''; // auf alle MSN reagieren!
begin
  // Lizenzen abfragen
  LizenzDatei := TStringlist.Create;
  try
  	LizenzDatei.LoadFromFile('lizenz.ini');
  except
  end;

  gLizenzName := InputBox( 'Lizenzabfrage', 'Bitte geben Sie den Lizenz-Namen ein.', LizenzDatei.Values['Name'] );
  gLizenzKey := InputBox( 'Lizenzabfrage', 'Bitte geben Sie den Lizenz-Schlssel ein.', LizenzDatei.Values['Key'] );

  // Eingegebene Daten sichern:
  LizenzDatei.Values['Name'] := gLizenzName;
  LizenzDatei.Values['Key'] := gLizenzKey;
  try
  	LizenzDatei.SaveToFile( 'lizenz.ini' );
  except
  end;


  // Programm starten
	ISDNDataHandle := ISDNCreate;
  // DLL Lizensieren
  if not ISDNLicense( ISDNDataHandle, PChar(gLizenzName), PChar(gLizenzKey) ) then
  	MessageBox(0, 'Das Telefonmodul wird im unlizensierten Modus gestartet. Bitte beachten Sie die in der Dokumentation erluterten Einschrnkungen.', 'Lizensierung fehlgeschlagen!', MB_Ok );

	InitParam.CallStateProc := CallStateProc;
	InitParam.TraceProc := TraceProc;
	InitParam.DTMFProc := DTMFProc;
	// NEU in Version 3.1: Auswahl der aktepzierten MSN
	// Leer=Alle annehmen, ansonsten: nur auf die angegebene MSN reagieren
	InitParam.AcceptMSN := constAcceptAllMSN;

// NEU in Version 4.0: neue Callbacks
	InitParam.QueryTapeProc := QueryTapeProc;

  bISDNInit := ISDNInit( ISDNDataHandle, @InitParam );

  //
  // Anpassung der Ton- und Pausenlngen, falls ntig
  //
  if bISDNInit then
  begin
    DTMFDurations.SendToneDuration := 80; // 80 Millisekunden
    DTMFDurations.SendGapDuration := 50; // 50 Millisekunden
    DTMFDurations.DetectToneDuration := 80; // 80 Millisekunden
    DTMFDurations.DetectGapDuration := 50; // 50 Millisekunden
    ISDNSetDTMFParams( ISDNDataHandle, @DTMFDurations );
  end;

  if not bISDNInit then
    begin
      Error := ISDNGetLastError( ISDNDataHandle );
      ISDNGetErrorText( ISDNDataHandle, Error, szBuffer );
      MessageBox( Handle, szBuffer, 'Fehler', MB_Ok );
    end;
end;

procedure TfrmCallcenter.FormDestroy(Sender: TObject);
begin
  ISDNDone( ISDNDataHandle );
  ISDNFree( ISDNDataHandle );
end;

procedure TfrmCallcenter.ButtonMakeCallClick(Sender: TObject);
begin
  if bISDNInit then
    ISDNMakeCall( ISDNDataHandle, PChar(EditMSN.Text), PChar(EditNr.Text) );
end;

procedure TfrmCallcenter.ButtonHangUpClick(Sender: TObject);
begin
  if bISDNInit then
    ISDNHangUp( ISDNDataHandle );
end;

procedure TfrmCallcenter.ButtonAcceptCallClick(Sender: TObject);
begin
  if bISDNInit then
    ISDNAcceptCall( ISDNDataHandle );
end;

procedure TfrmCallcenter.ButtonSendDTMFClick(Sender: TObject);
begin
  if bISDNInit then
    ISDNSendDTMF( ISDNDataHandle, PChar(EditDTMF.Text) );
end;

procedure TfrmCallcenter.VolumeChange(Sender: TObject);
var VolumeInfo: TVolumeInfo;
begin
  if (RBHandset.Checked) then
    VolumeInfo.AudioFrontEnd := AUDIOFRONTEND_HANDSET
  else
    VolumeInfo.AudioFrontEnd := AUDIOFRONTEND_HEADSET;

  VolumeInfo.Lautsprecher := TrackbarVolume.Position;
  VolumeInfo.Mikrophon := TrackbarVolume.Position;


	if bISDNInit then
		ISDNSetVolume(ISDNDataHandle, @VolumeInfo );
end;

procedure TfrmCallcenter.BtnSendWaveClick(Sender: TObject);
begin
	if bISDNInit then
	if Length(EditWavefilename.Text)>0 then
		ISDNSendWavefile(ISDNDataHandle, PChar(EditWavefilename.Text));
end;

procedure TfrmCallcenter.BtnECTClick(Sender: TObject);
begin
	if bISDNInit then
		ISDNExplicitCallTransferTo( ISDNDataHandle, PChar(EditMSN.Text), PChar(EditECTDestination.Text) );
end;

procedure TfrmCallcenter.SEHandsetMicChange(Sender: TObject);
var vol: TDivaCTVolumeInfo;
begin
	if bISDNInit then
	begin
		vol.Handset_MicVol := SEHandsetMic.Value;
		vol.Handset_SpkVol := SEHandsetSpk.Value;
		vol.Speakerphone_MicVol := SEspMic.Value;
		vol.Speakerphone_SpkVol := SEspSpk.Value;
		vol.HandsetandSpeakerphone_SpkGain := SESpkGain.Value;
		vol.HandsetandSpeakerphone_MicGain := SEMicGain.Value;

		ISDNSetVolumeEx( ISDNDataHandle, VOLUMEEX_SETDIVACTVOLUME, @Vol );
	end;
end;

procedure TfrmCallcenter.RBDIVAHandsetClick(Sender: TObject);
begin
	if bISDNInit then
	begin

		if (RBDIVAHandset.Checked) then
			ISDNSetVolumeEx( ISDNDataHandle, VOLUMEEX_SETDIVACTMODE_HANDSET, nil )
		else
			ISDNSetVolumeEx( ISDNDataHandle, VOLUMEEX_SETDIVACTMODE_SPEAKERPHONE, nil )
	end;
end;

end.
